<?php

/**
 * @file
 * @TODO add file description
 */

namespace Drupal\messagebird\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class MessagebirdTestForm
 * @package Drupal\messagebird
 */
class MessagebirdTestForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'messagebird_test';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form['originator'] = array(
      '#type' => 'textfield',
      '#title' => t('Originator'),
    );

    $form['recipient'] = array(
      '#type' => 'textfield',
      '#title' => t('Recipient'),
      '#required' => TRUE,
    );

    $form['body'] = array(
      '#type' => 'textarea',
      '#title' => t('Body'),
      '#required' => TRUE,
    );

    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Send message'),
    );

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $service = \Drupal::service('messagebird.service');
    $message_sent = $service->sendMessage($form_state->getValue('body'), $form_state->getValue('recipient'), $form_state->getValue('originator'));

    if ($message_sent) {
      drupal_set_message(t('The message was successfully sent.'));
    }
    else {
      drupal_set_message(t('An error occurred while sending the message. Check the logs for details.'), 'error');
    }
  }

}